# [UI Router for React](https://ui-router.github.io/react/docs/latest)

#### State based routing for React

<div style="display: flex;">

<iframe style="display: inline-block;" src="https://ghbtns.com/github-btn.html?user=ui-router&repo=react&type=fork&count=true&size=medium" frameborder="0" scrolling="0" width="110px" height="20px"></iframe>
<iframe style="display: inline-block;" src="https://ghbtns.com/github-btn.html?user=ui-router&repo=react&type=star&count=true&size=medium" frameborder="0" scrolling="0" width="110px" height="20px"></iframe>
[![Build Status](https://travis-ci.org/ui-router/react.svg?branch=master)](https://travis-ci.org/ui-router/react)

</div>


UI-Router React is a client-side [Single Page Application](https://en.wikipedia.org/wiki/Single-page_application) 
routing framework for [React](https://facebook.github.io/react/).  

**[View on Github](http://github.com/ui-router/react) |**
**[View ui-router-core on Github](http://github.com/ui-router/core) |**
**[Tutorials](https://ui-router.github.io/react/tutorials/) |**
**[Guides](https://ui-router.github.io/guide) |**
**[Sample App](http://ui-router.github.io/resources/sampleapp/)**
  
#### API Documentation Organization

The documentation is arranged according to API concern, such as `components`, `url`, `resolve`, and `core`.
By default, only the public API is shown.
To view both public API and the internal APIs, check the "Internal UI-Router API" checkbox.

#### Typescript

UI-Router is written in Typescript.
The API documentation is generated using [TypeDoc](https://github.com/TypeStrong/typedoc).
The documentation reflects the Typescript classes, interfaces, and parameter types information embedded in the source code.

#### Contributing

UI-Router React depends on the framework agnostic `ui-router-core`.
To contribute to the documentation, please submit a PR to either 
[ui-router-react](http://github.com/ui-router/react)
or
[ui-router-core](http://github.com/ui-router/core).
To find where a specific piece of API documentation is written, follow the links that say:
 > _Defined in ui-router/somedir/somefile.ts_


